;
;DUALIO.ASM an Interface program for the Osborne I
;Howard Moulton
;53 Congress St.
;Milford, Ma. 01757
;1-617-478-3693 voice
;1-617-478-4164 RCPM
;
;Instructions for installing follow:
;
;This is a program that is much in the same idea
;as BYE.ASM which is a very popular program that
;allows the local console and the RS232 port to
;control the computer. The exception to this
;program is that it must be installed using DDT,
;or similar program, on the disk which will be
;the "SYSTEM" disk while the system is "ONLINE".
;This program will detect the baud rate - only two
;are available at the moment - the need for others
;are really not necessary, so consequently, we
;only look for 300 and 1200 baud. Not many come in
;on any other baud, with the exception of 110, for
;which the Osborne is incapable.
;The modem, of course, must be capable of
;detecting 1200 baud, and have its own inteligence
;to switch itself to that rate - most modems
;do, if it's 212a.
;I might point out some things this program will,
;and will not do - 
;All I/O goes through this program - both the
;local console, as well as the RS232 port are
;"looked at" - from the CP/M point of view, it
;doesn't even realize where the characters are
;coming from, or going to. Both consoles see what
;is printed - program resets CP/M and waits until
;another carrier is seen if nothing is there, or
;if the carrier is lost, software will allow
;2-3 seconds before assuming carrier was lost,
;because we somtimes get callers from Calif. and
;the repeaters between the 2 points cause a delay.
;Somtimes the delay is so great, that carrier is
;lost for a sec while they are switching.
;There is a timer within pgm to give a couple
;of seconds for carrier to return before system
;assumes the carrier was lost.
;On carrier loss, the system resets, after setting
;flags in low memory - so beware of what you
;"POKE" down in page zero memory.
;
;This program resides in memory just above the
;CBIOS in an Osborne I.
;
;TO INSTALL:
:First, start with a FRESH diskette.
;Use MOVCPM.COM to reconfigure your operating
;system to 58k - WILL NOT WORK WITH 60K SYSTEMS.
;The reason is ONLY 60k, for some strange reason,
;will cause the operating system to use ALL the
;sectors on track 2. When reconfigured for anything
;less than 60k, the last 4 sectors become dormant.
;The reason for this is unknown to me - and we all
;know how much Osborne likes to tell us the
;"WHY'S" of this system, let alone, the "HOW'S".
;To continue, the MOVCPM program should be called
;in the following manner:
;
;A>movcpm 58 *	 (hit return)
;
;FAILURE TO SPECIFY THE "*" WILL CAUSE MOVCPM TO
;TO RECONFIGURE AT 58K, AND TRY TO EXECUTE IT.
;DEVASTATING RESULTS ARE GAURANTEED TO
;OCCUR, LIKE UNWANTED DISK ACCESS, WRITES, AND THE
;LIKE - don't forget the "*"....
;If called properly, the msg:
;
;CONSTRUCTING 58K CP/M
;READY FOR "SYSGEN"  OR
;SAVE 39 CPM58.COM       (or similar message)
;
;Type the following after the A> appears:
;
;A>save 39 cpm58.com
;
;This saves the newly reconfigured system to disk
;as a file for merging later.
;Next, assemble DUALIO, with the resulting files
;residing on your work disk - the one you are
;USING to make the system - not the one that WILL
;be the system disk -
;Next, use the command (assuming you have DDT.COM
;on your WORK disk)
;
;A>ddt cpm58.com   (hit return)
;
;DDT will come in and pull CPM58.COM with - the
;following message should be seen....
;
;DDT VER 2.2
;NEXT   PC
;2800  0100
;-
;Now type:
;-idualio.hex	  (hit return)
;
;Nothing should happen now...
;type:
;
;-r4280
;
;Now disk should operate, and if ok, you should
;see the computer bark back at you:
;
;NEXT  PC
;2800 0000
;
;At this point, you have got the OSDUALIO.ASM
;interfaced to CP/M - and we are nearly done.
;Type:
;
;-l1f80
;
;You should see something like....
;
;1F80	JMP DF0C
;1F83	JMP xxxx
;1F86	JMP xxxx .....ect.
;
;This is the jump table CP/M uses to comunicate
;to the computer it resides in. If you don't
;see this, STOP and start over - you didn't
;tell MOVCPM to reconfigure for 58k, or didn't
;tell DDT to pull it in.
;Now, type the following using these HEX values:
;
;-a1f86   (hit return)
;DDT will type the address - you type after it...
;
;1F86	jmp e300      (hit return)
;1F89	jmp e321      (hit return)
;1F8C	jmp e346      (hit return)
;1F8F	.	      (type a period, and return)
;
;After the "-", type a ctl-c - this take you out
;of DDT without destroying the image in the TPA.
;Now type, WITHOUT TYPING ANY OTHER COMMAND BEFORE
;IT:
;
;A>save 39 cpm58.com  (hit return)
;
;Now we can put the interfaced system on the new
;"SYSTEM" disk.
;Assuming you have SYSGEN.COM on your work disk,
;type the following EXACTLY:
;
;A>sysgen cpm58.com   (hit return)
;
;Sysgen will ask you for the DESTINATION drive -
;if you did it properly, the new disk should be
;in B drive, so type B and hit return.
;After SYSGEN does his thing, reset the system.
;Cause the "NEW" system disk to boot by typing
;" (shift-quote) to see if you made it....
;If you don't have a modem plugged in the RS232
;port, you see an infinity of...
;
;Hit return key please.....
;
;This means the program is looking for a return
;as long as the carrier is there - since the port
;is expecting NOT values at the CD pin (pin 8),
;the sys "THINKS" there is a carrier, so hence
;the message.
;
;You might want to change the "AUTOST" to something
;else, or rename the program you want to come up
;as AUTOST.
;All the utilities such as "SETUP.COM" and
;"AUTOSET.COM" will work with this interface, as
;well as "SYSGEN" for copying the system tracks
;to another diskette.
;Good luck - any trouble? Call me after 6PM wkdys
;or most weekends....Howard
;
;
;THE NUMBER OF ERRORS ALLOWED ON LOG-IN BEFORE DISC.
MAXERR	EQU	10
;
BDOS	EQU	5
;
;
	ORG	0E300H	;DON'T CHANGE THIS ADDRESS
;
;CHECK STATUS OF CONSOLES - NON-ZERO MEANS
;CHAR IS READY - WE DO NOT GET CHAR - ONLY
;STATUS 
	LDA	BFLG	;GET COLDBOOT FLG
	ORA	A	;WAS A COLDBOOT...
	CNZ	SETBD	;PERFORMED?
	LDA	CFLG
	ORA	A
	JNZ	FLGOF
	CALL	CARD
	CALL	0E10BH	;CHECK CONSOLE FIRST
	RNZ		;NOT 0 = CHAR READY - DON'T BOTHER WITH PORT
	CALL	CGON
	CALL	GSTAT	;GET STATUS
	ANI	01	;ANYTHING AVAILABLE?
	RZ		;NOPE - GO HOME
	MVI	A,255	;YES, TELL BDOS
	RET
;
;THIS GETS A CHAR - FIRST LOOKS TO FIND OUT WHICH HAS IT..
;THIS INPUT ROUTINE WILL LOOP HERE UNTIL
;CHARACTER RECIEVED BY ONE OR THE OTHER
GET	LDA	BFLG
	ORA	A
	CNZ	SETBD
	LDA	CFLG	;GET STATUS OF LAST I/O OPER.
	ORA	A	;WAS CARR. LOST?
	JNZ	FLGOF	;YES - MUST HAVE JUST CAME FROM WBOOT
	CALL	CARD	;CHECK FOR CARRIER FIRST
	CALL	0E10BH	;CHECK CONSOLE FIRST
	JNZ	0E110H	;MUST HAVE BEEN ONE THERE
	CALL	GSTAT
	ANI	01
	JZ	GET
;MUST BE A CHARACTER HERE - GET IT
	CALL	GDATA	;RETURNS W/CHAR IN A
	ANI	7FH	;KILL PARITY
	RET		;RETURN W/CHAR IN A
;
;SEND CHAR ROUTINES - SENDS TO BOTH I/O..
PUT	LDA	BFLG
	ORA	A
	CNZ	SETBD
	LDA	CFLG	;WAS CARR LOST
	ORA	A	;CARR LOST?
	JNZ	FLGOF	;YES - RESET IT - GET A CALLER
	CALL	CGON
	CALL	CARD	;CHECK CARR FIRST
	DI
	OUT	00
	MOV	A,C
	STA	2A01H
	OUT	01
	EI
	JMP	0E115H	;JMP TO CONOUT
;
;THE FOLLOWING USED BY CBBS TO DISCONNECT A CALLER
;VIA THE "G" COMMAND - SO USER DOESN'T HAVE TO
;GO INTO CP/M TO TYPE "BYE".
OFF	XRA	A	;ZERO OUT A
	STA	ERRCNT	;SHOW NO ERRORS
	MVI	C,72H	;GET VALUE FOR DISC.
	CALL	0DD3CH	;SEND TO PORT
	CALL	TIMER	;GIVE 6850 TIME TO DO IT
	JMP	0	;FAKE A CTL-C
;
;*************************************************
;IF YOU MAKE ANY CHANGES ABOVE THIS POINT, THE
;ADDRESSES WILL CHANGE FROM WHAT IS IN THE IN-
;STRUCTIONS - YOU'LL HAVE TO ASSEMBLE IT WITH
;THE "X" OPTION ON THE ASSEMBLER TO FIND OUT
;WHAT THEY WILL BE.
;*************************************************
;
;ROUTINE TO FIND OUT IF CARRIER THERE
;FIRST MAKE SURE THAT ALL BITS SENT FROM LAST CHAR
;ELSE ERRONEUS RESULTS ARE READ FROM STATUS
CARD	CALL	GSTAT	;GET CURRENT STATE
	ANI	04	;STILL WITH US?
	RZ		;YES - CONT
;
;GIVE TIME FOR POSSIBLE GARBAGE LINE...
	CALL	TIMER
	CALL	GSTAT
	ANI	04	;CARRIER BACK NOW?
	RZ		;CARRIER CAME BACK
;CALLER LOST - DROP INTO HERE FOR NEW CALLER
;SET FLAG AND JMP TO 0 TO RESET BDOS INTERNALLY
;(FOR SOME REASON, IF CALLER HANGS UP IN ANY PGM
;EXCEPT CCP, BDOS GOES BANANAS - SOMETHING TO DO
;WITH BDOS'S STACK I THINK)
FLGON	XRA	A	;CLEAR A + FLAGS
	STA	ERRCNT	;SHOW NO ERRORS
	DCR	A	;MAKE 255
	STA	CFLG	;TELL PRINT/INPUT ROUTINES THAT CARRIER LOST
	JMP	0	;GOCPM TO FAKE BDOS
;COME HERE WHEN CARR. LOST AFTER BDOS RESET AND CLEAR FLAG
FLGOF	XRA	A
	STA	CFLG	;SHOW CARR NOT LOST
;FALL INTO LOOKING FOR A CALLER
LOOK	LXI	SP,STACK
	MVI	A,52H	;GET 300 INITIALLY
	STA	BRB	;BOOT-UP
	MOV	C,A
	CALL	0DD3CH	;SETUP PORT @ 300
	CALL	GSTAT	;GET STATUS OF PORT
	NOP		;THESE GIVE DISK
	NOP		;TIME TO SHUT OFF
	ANI	04	;GOT A CARRIER?
	JNZ	LOOK	;NOPE - KEEP LOOKING
;CARRIER CAME UP - IT'S A GO
;THIS IS WHERE WE TEST FOR BAUD RATE - JUST
;TOGGLES BACK TO 300 AND 1200 IF CAN'T READ A
;CR, OR CARRIER LOST....
GETCR	LDA	ERRCNT	;GET CURRENT ERROR COUNT
	CPI	MAXERR
	JZ	OFF	;YES, LOG-OFF
	INR	A	;NO, BUMP ERROR COUNT
	STA	ERRCNT	;STORE NEW ERROR COUNT
	LXI	D,CRMSG
	MVI	C,9
	CALL	BDOS
	CALL	GET
	CPI	13	;CR?
	JZ	GOTCR
	CALL	TIMER
	LDA	BRB
	CPI	52H
	JZ	T1200	;TRY 1200 BAUD
	MVI	A,52H	;SETUP FOR 300
	JMP	CBAUD
T1200	MVI	A,51H	;GET 1200
CBAUD	STA	BRB
	MOV	C,A
	CALL	0DD3CH	;CHANGE PORT
	CALL	TIMER	;6850 SLO
	JMP	GETCR	;TRY FOR CR
;
;GOT A CR SO MUST HAVE FOUND BAUD RATE
;TELL 'EM....
GOTCR	LXI	D,BDMSG
	MVI	C,9
	CALL	BDOS
	LDA	BRB	;GET BAUD RATE
	CPI	52H	;300?
	JNZ	GOTCRH	;NO, MUST BE HI-SPEED
	LXI	D,LSMSG
	JMP	GOTCR1
GOTCRH	LXI	D,HSMSG
GOTCR1	MVI	C,9
	CALL	BDOS
	LXI	D,INMSG
	MVI	C,9
	CALL	BDOS
	MVI	A,255	;SHOW THAT A COLD
	STA	BFLG	;WAS PERFORMED
	XRA	A
	JMP	0DF0CH	;RESET CP/M
;
;TIMER ROUTINE - GIVES APPRO. 3 SEC. IF CARRIER DROPS
;SO WE DON'T JUMP BACK TO "HIT CR.." DUE TO BAD LINE
TIMER	PUSH	D	;SAVE IN CASE BDOS WAS USING IT
	LXI	D,65535	;MAX OUT D+E FOR A COUNT
TIMER1	DCX	D	;BUMP THE COUNTER
	MOV	A,D	;MOVE IT INTO A FOR.....
	ORA	E	;COMPARE FOR 00 IN BOTH
	JNZ	TIMER1	;ONE OR BOTH NOT 0 - DO MORE..
	POP	D	;GET BACK D+E FOR BDOS
	RET		;GO BACK FROM WHENCE YOU CAME...
;
;CHECK TO MAKE SURE ALL BITS SENT FOR STAT
;CHECK ELSE ERRONEUS RESULTS MAY OCCUR..
CGON	DI		;DISABLE INTERRUPTS
	OUT	00	;BANK 0
CGON1	LDA	2A00H	;GET STATUS
	ANI	02
	JZ	CGON1
	OUT	01	;BANK 1
	EI
	RET
;
;ROUTINE TO GET STATUS OF RS232 PORT
GSTAT	DI
	OUT	00
	LDA	2A00H
	OUT	01
	EI
	RET		;RETURN W/RESULTS
;
;ROUTINE TO GET DATA FROM PORT
GDATA	DI
	OUT	00
	LDA	2A01H
	OUT	01
	EI
	RET
;
;ROUTINE TO RESET BAUD LOGGED IN ON IF
;A COLDSTART WAS PERFORMED 'CAUSE A
;COLDSTART WILL CAUSE BAUD RATE TO BE SET
;AT WHAT DISK IS CONFIGURED AT...
SETBD	PUSH B!PUSH D!PUSH H ;SAVE ALL REGS
	LDA	BRB	;GET CURRENT BAUD
	MOV	C,A
	CALL	0DD3CH
	POP H!POP D!POP B
	XRA	A
	STA	BFLG	;SHOW NO COLDBOOT
	RET
;
CRMSG DB 13,10,13,10,'Hit return key please....$'
;
BDMSG DB 13,10,13,10,'Baud rate detected: $'
;
LSMSG DB '300 (103 standard.)',13,10,'$'
HSMSG DB '1200 (212A standard).',13,10,'$'
;
;
INMSG DB 10,13,10,'You have reached Milford RCPM.'
 DB 13,10,10,'Loading CBBS(R)....'
 DB '$$'
;
	DS	36
STACK	EQU	$
CFLG	EQU	03CH	;USED BY I/O TO DETERMINE IF CARRIER WAS LOST
BRB	EQU	03DH	;LOCATION OF BAUD RATE LOGGED IN ON...
BFLG	EQU	03EH	;COLDBOOT FLAG
ERRCNT	EQU	03FH	;# OR ERRORS OCCURED
